"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var visitSchema_1 = require("../transforms/visitSchema");
var visitObject_1 = require("../transforms/visitObject");
function RenameTypes(renamer) {
    var reverseMap = {};
    return {
        transformSchema: function (originalSchema) {
            return visitSchema_1.visitSchema(originalSchema, (_a = {},
                _a[visitSchema_1.VisitSchemaKind.TYPE] = function (type) {
                    var newName = renamer(type.name);
                    if (newName && newName !== type.name) {
                        reverseMap[newName] = type.name;
                        var newType = Object.assign(Object.create(type), type);
                        newType.name = newName;
                        return newType;
                    }
                },
                _a[visitSchema_1.VisitSchemaKind.ROOT_OBJECT] = function (type) {
                    return undefined;
                },
                _a));
            var _a;
        },
        transformRequest: function (originalRequest) {
            var newDocument = graphql_1.visit(originalRequest.document, (_a = {},
                _a[graphql_1.Kind.NAMED_TYPE] = function (node) {
                    var name = node.name.value;
                    if (name in reverseMap) {
                        return __assign({}, node, { name: {
                                kind: graphql_1.Kind.NAME,
                                value: reverseMap[name],
                            } });
                    }
                },
                _a));
            return {
                document: newDocument,
                variables: originalRequest.variables,
            };
            var _a;
        },
        transformResult: function (result) {
            if (result.data) {
                var newData = visitObject_1.default(result.data, function (key, value) {
                    if (key === '__typename') {
                        return renamer(value);
                    }
                });
                var newResult = __assign({}, result, { data: newData });
                return newResult;
            }
            return result;
        },
    };
}
exports.default = RenameTypes;
//# sourceMappingURL=RenameTypes.js.map