"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var schemaGenerator_1 = require("../schemaGenerator");
var transforms_1 = require("../transforms/transforms");
var resolvers_1 = require("../stitching/resolvers");
function makeSimpleTransformSchema(targetSchema, transforms) {
    var schema = transforms_1.applySchemaTransforms(targetSchema, transforms);
    var mapping = resolvers_1.generateSimpleMapping(targetSchema);
    var resolvers = resolvers_1.generateProxyingResolvers(targetSchema, transforms, mapping);
    schemaGenerator_1.addResolveFunctionsToSchema(schema, resolvers, {
        allowResolversNotInSchema: true,
    });
    return schema;
}
exports.default = makeSimpleTransformSchema;
//# sourceMappingURL=makeSimpleTransformSchema.js.map