"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function visitObject(object, visitor) {
    return visitObjectImpl(object, visitor, []);
}
exports.default = visitObject;
function visitObjectImpl(object, visitor, parents) {
    if (isObject(object)) {
        var result_1 = {};
        Object.keys(object).forEach(function (key) {
            var value = object[key];
            var processedValue = visitor(key, value, parents);
            var nextValue;
            if (typeof processedValue === 'undefined') {
                nextValue = value;
            }
            else if (processedValue === null) {
                return;
            }
            else {
                nextValue = processedValue;
            }
            result_1[key] = visitObjectImpl(nextValue, visitor, [key].concat(parents));
        });
        return result_1;
    }
    else {
        return object;
    }
}
function isObject(item) {
    return item && typeof item === 'object' && !Array.isArray(item);
}
//# sourceMappingURL=visitObject.js.map